# Guard.pm -- :LavaBot:Guard:

package Guard;

use Msg_parse;

my $_name;  ### updated in g_timer
my $_channel;
my $_timer;
my $_kickedby = "zero";
my $_alive;
my $_trylimit;
my $_lastkicktimer = 0;
my %awaiting;

sub init {
	$_channel = shift;
	IRC::print("Guard: init... ");
	$_alive = "true";
	$_timer = 3000;
	$_trylimit = 4;
	%awaiting = ("unban" => 0,
			"join" => 1,
			"op" => 0,
			"voice" => 0,
		     );
	IRC::add_timeout_handler($_timer, Guard::g_timer);
	IRC::add_message_handler('MODE', Guard::g_ircsub_mode);
	IRC::add_message_handler('KICK', Guard::g_ircsub_kick);
	# IRC::add_message_handler('JOIN', Guard::g_ircsub_join);  ### is this right?

	IRC::add_message_handler('NOTICE', Guard::privmsg);  #easily breakable
	IRC::add_message_handler('474', Guard::g_upon_ban); #can't join chan
	IRC::add_message_handler('482', Guard::g_upon_deop); #not chop
	IRC::print(" done.\n");
}

sub g_ircsub_mode {
	my $line = shift;
	if ((&get_target($line) ne $_channel) or !$_alive) {
		IRC::print("target failed: " . &get_target($line) . ", " . $_channel . "\n");
		return;
	}
	my $body = &get_body($line);
	my $handle = &get_handle($line);
	my @tokens = split(" ", $body);
	my $modes = shift @tokens;
	my $sign = 1;
	my $t = 0;
	my ($i, $byte);
	for ($i = 0; $i <= length $modes; $i++) {
		$byte = substr($modes, $i, 1);
		if ($byte eq "+") {
			$sign = 1;
			next;
		} elsif ($byte eq "-") {
			$sign = 0;
			next;
		}
		if (($byte eq "b") and &mask_match($tokens[$t++], &main::my_handle())) {
			if ($sign == 1) {
				&g_upon_ban;
			} else {
				&g_upon_unban;
			}
			next;
		}
		if (($byte eq "o") and ($tokens[$t++] =~ /$_name/o)) {
			if ($sign) {
				&g_upon_op;
				IRC::print("** i was opped **\n");
			} else {
				&g_upon_deop;
				IRC::print("** i was deopped **\n");
			}
			next;
		}
		if (($byte eq "v") and ($tokens[$t++] =~ /$_name/og)) {
			if ($sign) {
				&g_upon_voice;
				IRC::print("** i was voiced **\n");
			} else {
				&g_upon_devoice;
				IRC::print("** i was devoiced **\n");
			}
			next;
		}
		if ($byte eq "l" or $byte eq "k") {
			$t++;
		}
	}
	return;
}

sub g_ircsub_kick {
	my $line = shift;
	if (!$_alive) {
		return;
	}
	if (&get_target($line) ne $_channel) {
		return;
	}
	my @body = split(" ",&get_body($line));
	my $kickee = shift @body;
	if ($kickee eq $_name) {
		my $kicker = &get_domain($line);
		$_lastkicktimer = 0;
		if (($_kickedby ne "zero") and ($_kickedby ne $kicker)) {
			my $temp = &get_name($line);
			IRC::command("/msg $temp I resign. Enjoy the peace.");
			&g_upon_resign;	
			return;
		}
		$_kickedby = &get_domain($line);
		&g_upon_kick;
	}
	return;
}

sub g_ircsub_join {
### omg, does this never get called?  WHY NOT?!?!
	if (!$_alive) {
		return;
	}
	if (&get_body(shift) =~ /$_channel/o) {
		&g_upon_join;
	}
	return;
}

sub g_ircsub_part {
	if (!$_alive) {
		return;
	}
	if (&get_body(shift) =~ /$_channel/o) {
		&g_upon_resign;
	}
	return;
}

sub g_upon_ban 		{ $awaiting{"unban"} = 1; }
sub g_upon_unban 	{ $awaiting{"unban"} = 0; }
sub g_upon_op 		{ $awaiting{"op"} = 0; }
sub g_upon_deop		{ $awaiting{"op"} = 1; }
sub g_upon_voice	{ $awaiting{"voice"} = 0; }
sub g_upon_devoice	{ $awaiting{"voice"} = 1; }
sub g_upon_kick		{ $awaiting{"join"} = 1; }
sub g_upon_join 	{ $awaiting{"join"} = 0;
			  $awaiting{"unban"} = 0;
			  $awaiting{"op"} = 1; }

sub g_upon_resign	{
	####  HEY!!  do a main::unload_mod("Guard") or whatever
	&stop;
}

sub g_timer {
	if (!$_alive) {
		return;
	}
	$_name = IRC::get_info(1);
	if ($_lastkicktimer++ > 4) {
		$_kickedby = "zero";
	}
	if ($awaiting{"unban"}) {
		if ($awaiting{"unban"}++ < $_trylimit) {
			IRC::command("/msg ChanServ unbanme $_channel");
		}
	} elsif ($awaiting{"join"}) {
		if ($awaiting{"join"}++ < $_trylimit) {
			IRC::command("/join $_channel");
		}
	} elsif ($awaiting{"op"}) {
		IRC::print("awaiting ops...\n");
		if ($awaiting{"op"}++ < $_trylimit) {
			IRC::print("w00t, everything clear\n");
			IRC::command("/msg ChanServ opme $_channel");
		}
	} elsif ($awaiting{"voice"}) {
		if ($awaiting{"voice"}++ < $_trylimit) {
			IRC::command("/mode $_channel +v $_name");
		}
	}
	foreach $temp (keys %awaiting) {
		if ($awaiting{$temp} >= $_trylimit) {
			$awaiting{$temp} = 0;
		}
	}
	IRC::add_timeout_handler($_timer, Guard::g_timer);
}

sub chanmsg {
	return;
}

sub privmsg {
	my $line = shift;
	if (!$_alive) {
		return;
	}
	if (&get_name($line) =~ /chanserv/i) {
		my @body = split(" ",&get_body($line));
		my $response = shift @body;
		if ($response =~ /unbanned/i) {
			&g_upon_unban;
		} else {
			IRC::print("not uunbannedd\n");
		}
	}
	return;
}

sub stop {
	### disable the goddamn thing, man!
	$_alive = 0;
	return;
}

1; 	# fucking compatibility

