#!/usr/bin/perl -w

package         Leetize;
require         Exporter;
@ISA            =       qw(Exporter);
@EXPORT         =       qw(leetize);
@EXPORT_OK      =       qw ();

sub leetize {
### pass in: a nonl33t scalar
### returns: a l33t version of that scalar
	my $nonleet = shift;
	chomp $nonleet;
	$nonleet =~ s/\s+/ /g;
	my @werds = split(" ",$nonleet);
	
	my $werd;
	foreach $werd (@werds) {
	        $werd = &leetizewerd($werd);
	}

	$werds[$#werds] =~ s/(!+|\.)$/&randomreturn(", f00l", 15, "!! ph33r", 12, "! w3rd", 12, ", w4r3z d00d", 12, "! 0wn4g3", 12, "! p1mP", 12, "")/e;
	$werds[$#werds] .= &trail((rand) * 15 + 3);
	
	unless ($werds[0] =~ /(,|\.|!)$/) {
	        $werds[0] = &randomreturn("d00dZ" . &trail((rand) * 8 + 4) . " ", 20, "") . $werds[0];
	}
	return join(" ",@werds);
}

sub trail {
### pass in: length of trail in chars
### returns: something that looks like this -> !!!!!!!@#!#!%#$%!#$%!!1
        my $lenth = shift;
        my $strng = "";
        my $count;
        for ($count = 0; $count <= $lenth; $count++) {
                $tempprob = 120*($lenth - $count)/$lenth;
                $strng .= &randomreturn("!", 120*($lenth - $count)/$lenth, "@", $tempprob, "#", $tempprob, "\$", $tempprob, "\%", $tempprob, "*");
        }
        return $strng;
}

sub leetizewerd {
### pass in: werd
### returns: a l33t werd
        my $werd = shift;
        if ($werd =~ /(^u$)|(^you[^\w]*$)/i) {
                return &randomreturn("j00", 75, "U");
        }
        if ($werd =~ s/^(.+[^c])(c*k|x)$/$1x0rZ/ig) {
		return $werd;
	}
        if ($werd =~ /^(your|ur|yer|you\'re)$/i) {
                return "uR";
        }
	if ($werd eq "for") {
		return "4";
	}
	if (($werd eq "too") or ($werd eq "to")) {
		return "2";
	}
	if ($werd eq "I") {
		return &randomreturn("3Y3", 25, "i");
	}
        $werd =~ s/a/&randomreturn("\@",50,"4")/igeo;
        $werd =~ s/c/&randomreturn("(",50,"c")/igeo;
        $werd =~ tr/eE/33/;
        $werd =~ s/g/&randomreturn("6",25,"G")/igeo;
        $werd =~ tr/oO/0/;
        $werd =~ s/s/&randomreturn("5",75,"S",75,"Z")/igeo;
        $werd =~ s/t/&randomreturn("+",30,"7",25,"T")/igeo;
        $werd =~ s/v/&randomreturn("\\\/", 25, "V")/igeo;
	if ($werd =~ /i/ig) {
               $werd =~ tr/iI/11/;
        } else {
               $werd =~ s/L/&randomreturn("1",50,"L")/igeo;
	}
        return $werd;
}

sub randomreturn {
### pass in: a list = (word, probability, word, probability, etc...)
### returns: one word, randomly selected from the list
### note: the words/prob's are evaluated in order, so each probability should
###       be chosen based on the assumption that the previous one failed.
###       eg: ('a', 50, 'b', 50, 'c', 100)  has a 1/4 chance of returning b
###       the final word's probability is always 100.

        my @stuff = @_;
        my @words = ();
        my @probabilities = ();
        my $boolean = 1;
        while (scalar @stuff) {
                if ($boolean) {
                        push @words, shift @stuff;
                } else {
                        push @probabilities, shift @stuff;
                }
                $boolean = !$boolean;
        }
        my $i;
        for ($i = 0; $i <= $#words; $i++) {
                if ($#probabilities < $i) {
                        return $words[$i];
                }
                if ($probabilities[$i] > rand 100) {
                        return $words[$i];
                }
        }
        return $words[$#words];
}

1;    # fucking compatibility
