# Msg_parse.pm
package		Msg_parse;
require		Exporter;
@ISA		=	qw(Exporter);
@EXPORT		=	qw(get_name get_name_from_handle get_login get_login_from_handle get_body get_target get_handle get_domain get_domain_from_handle mask_match valid_handle);
@EXPORT_OK	=	qw ();

sub get_name {
	my $temp = get_handle(@_);
	unless ($temp) { return 0; }
	my @temp = split("!", $temp);
	return $temp[0];
}

sub get_name_from_handle {
	my @temp = split("!", $_[0]);
	return $temp[0];
}

sub get_login {
	my $temp = get_handle(@_);
	unless ($temp) { return 0; }
	my @temp = split("!", $temp);
	@temp = split("@", $temp[1]);
	return $temp[0];
}

sub get_login_from_handle {
	my @temp = split("!", $_[0]);
	my @temp2 = split("@", $temp[1]);
	return $temp2[0];
}

sub get_handle {
	my @param = @_;
	if ($#param == -1) { return 0; }
	my @temp = split(":", $param[0]);
	@temp = split(" ", $temp[1]);
	return $temp[0];
}

sub get_domain {
	my $temp = get_handle(@_);
	unless ($temp) { return 0; }
	my @temp = split("@", $temp);
	return $temp[1];
}

sub get_domain_from_handle {
	my @temp = split("@", $_[0]);
	return $temp[1];
}

sub get_body {
        my @sect1 = split(" ", $_[0]);
        shift(@sect1);
        shift(@sect1);
        shift(@sect1);
	my $temp = join(" ",@sect1);
	$temp =~ s/^://g;
        return $temp;  #clips preceding colon
}

sub get_target {
        my @param = split(" ",$_[0]);
        return $param[2];
}

sub mask_match {
### pass in: two irc handles, one w/ metachars, the other explicit
### treats whichever handle contains *'s as the pattern, defaulting to the
###  first if both have *'s
### returns: 1 if they match, 0 otherwise
	my @masks = @_;
	my $temp1 = $masks[0];
	my $temp2 = $masks[1];
	$temp1 =~ s/[^(\w|-|\*|!|\@|~)]//g;
	$temp2 =~ s/[^(\w|-|\*|!|\@|~)]//g;
	if ($temp1 =~ /\*/) {
		$temp1 =~ s/\*/\.\*/g;
		$temp1 = "^" . $temp1;
		return ($temp2 =~ /$temp1/i);
	} else {
		$temp2 =~ s/\*/\.\*/g;
		$temp2 = "^" . $temp2;
		return ($temp1 =~ /$temp2/i);
	}
}

sub valid_handle {
### pass in: a handle, or a mask
### returns: 1 if it is of good form, 0 if not
	my @first = split("!", $_[0]);
	if ($#first != 1) {
		IRC::print("first check failed\n");
		return 0;
	}
	my @second = split("@", $first[1]);
	if ($#second != 1) {
		IRC::print("second check failed\n");
		return 0;
	}
	#if ($second[1] =~ /[^(\w|-|\*|~|\.)]/) {
	#	IRC::print("second 1 = ;$second[1];\n");
	#	return 0;
	#}
	if (($first[0] =~ /[^(\w|\-|\*|~|\.)]/) or
	   ($second[0] =~ /[^(\w|\-|\*|~|\.)]/) or
	   ($second[1] =~ /[^(\w|\-|\*|~|\.)]/)) {
		IRC::print("third check failed\n");
		return 0;
	}
	return 1;

}

1;   # fucking compatibility
